<template>
  <div class="container">
    <div class="section">
      <title-with-back :back="{ name: 'user-detail', params: { user } }">Edit User</title-with-back>
      <user-detail
        button="Save"
        :loading="loading"
        :name.sync="name"
        @submit="submit"
        @cancel="$router.back()"
      />
    </div>
  </div>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Prop } from 'vue-property-decorator';
  import { Repository } from '@/modals/user';

  @Component<UserEditPage>({
    components: {
      TitleWithBack: () => import('@/components/TitleWithBack.vue'),
      UserDetail: () => import('@/components/user/UserDetail.vue'),
    },
  })
  export default class UserEditPage extends Vue {
    loading: boolean = false;
    name: string = '';

    @Prop({
      type: String,
      required: true,
    }) user!: string;

    mounted() {
      this.loading = true;
      return Repository.get(this.user)
        .then(({ name }) => {
          this.name = name;
          this.loading = false;
        });
    }

    submit() {
      this.loading = true;
      return Repository.update(this.user, { name: this.name.trim() })
        .then(() => {
          this.$router.push({ name: 'user' });
        });
    }
  }
</script>
